﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace IncrementDecrementGUI
{
	/// <summary>
	/// Interaktionslogik für MainWindow.xaml
	/// </summary>
	public partial class IncrementDecrementView : Window
	{
		private IncrementDecrementViewModel viewModel;

		public IncrementDecrementView()
		{

			InitializeComponent();

			//ViewModel erzeugen
			viewModel = new IncrementDecrementViewModel();

			//Data-Context setzen
			DataContext = viewModel;

			//Event-Handler einrichten
			viewModel.UserFeedback += HandleUserFeedback;
		}

		public void HandleUserFeedback(object sender, EventArgs e)
		{
			valueBox.Text = viewModel.TextBoxValue;
			errorBox.Text = "Nur Zahlen als Eingabe erlaubt!";
			//MessageBox.Show("Falsche Eingabe für Textbox! Nur Zahlen erlaubt!");
		}

		private void Increment_Click(object sender, RoutedEventArgs e)
		{
			viewModel.IncrementTextBoxValue();
		}

		private void Decrement_Click(object sender, RoutedEventArgs e)
		{
			viewModel.DecrementTextBoxValue();
		}
	}
}
