﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NUnit.Framework;
using IcuTesting.WPF;
using IncrementDecrementGUI;
using System.Windows.Controls;
using System.Windows;

namespace IncrementDecrementTest
{
	[TestFixture]
	class IncrementDecrementGuiTests : NUnitIcuBase
	{
		//static GuiHelper GuiHelper = new GuiHelper();
		//static IcuTest ICU = IcuTestStarter.IcuFromDir(
		//        @"C:\Users\tobmuell\Documents\My Dropbox\SWQ\IncrementDecrementGUI\IncrementDecrementTest\test_data");

		[Test]
		public void RawWindowManualTest()
		{
			ICU.Invoke(() =>
			{
				var window = new IncrementDecrementView();
				window.Show();
				ICU.CheckView(window, "RawWindow");
				window.Close();
			});
		}

		[Test]
		public void RawWindowManualSafeTest()
		{
			ICU.Invoke(() =>
			{
				var window = new IncrementDecrementView();
				try
				{
					window.Show();
					ICU.CheckView(window, "RawWindow");
				}
				finally
				{
					window.Close();
				}
			});
		}

		[Test]
		public void RawWindowWithScenariosTest()
		{
			var context = new WindowScenario<IncrementDecrementView>();
			ICU.Given(context)
			.When(() =>
			{
				//Hier könen Vorbedingungen, die vor dem Test stattfinden sollen, stehen
			})
			.Then(() =>
			{
				var window = context.Window;
				ICU.CheckView(window, "RawWindow");
			})
			.Test();
		}

		[Test]
		public void WindowWithClicksTest1()
		{
			var context = new WindowScenario<IncrementDecrementView>();
			ICU.Given(context)
			.When(() =>
			{
				Window window = context.Window;
				Button incrementButton = GuiHelper.Find<Button>(window, "incrementButton");
				Button decrementButton = GuiHelper.Find<Button>(window, "decrementButton");
				GuiHelper.Click(incrementButton);
				GuiHelper.Click(incrementButton);
				GuiHelper.Click(decrementButton);
			})
			.Then(() =>
			{
				Window window = context.Window;
				ICU.CheckView(window, "WindowWithValueOne");
			})
			.Test();
		}

		[Test]
		public void WindowWithClicksTest2()
		{
			var context = new WindowScenario<IncrementDecrementView>();
			ICU.Given(context)
			.When(() =>
			{
				Window window = context.Window;
				Button incrementButton = GuiHelper.Find<Button>(window, "incrementButton");
				Button decrementButton = GuiHelper.Find<Button>(window, "decrementButton");
				GuiHelper.Click(incrementButton);
				GuiHelper.Click(incrementButton);
				GuiHelper.Click(decrementButton);
				GuiHelper.Click(incrementButton);
				GuiHelper.Click(decrementButton);
				GuiHelper.Click(incrementButton);
			})
			.Then(() =>
			{
				Window window = context.Window;
				ICU.CheckView(window, "WindowWithValueTwo");
			})
			.Test();
		}

		[Test]
		public void WindowWithWrongTextBoxValueTest()
		{
		    var context = new WindowScenario<IncrementDecrementView>();
		    ICU.Given(context)
		    .When(() =>
			{
				Window window = context.Window;
		        TextBox valueBox = GuiHelper.Find<TextBox>(window, "valueBox");
		        GuiHelper.SetText(valueBox, "a");
		    })
		    .Then(() =>
			{
				Window window = context.Window;
		        ICU.CheckView(window, "WindowWithWrongTextBoxValue");
		    })
		    .Test();
		}

		[Test]
		public void WindowTest()
		{
		    GuiHelper guiHelper = new GuiHelper();
		    var context = new WindowScenario<IncrementDecrementView>();
		    ICU.Given(context)
		    .When(() =>
			{
				Window window = context.Window;
		        Button incrementButton = guiHelper.Find<Button>(window, "incrementButton");
		        Button decrementButton = guiHelper.Find<Button>(window, "decrementButton");
		        TextBox valueBox = GuiHelper.Find<TextBox>(window, "valueBox");
		        guiHelper.SetText(valueBox, "7");
		        guiHelper.Click(incrementButton);
		        guiHelper.Click(incrementButton);
				//guiHelper.Click(decrementButton);
		    })
		    .Then(() =>
			{
				Window window = context.Window;
		        ICU.CheckView(window, "WindowWithValueEight");
		    })
		    .Test();
		}
	}
}
