﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using IcuTesting.WPF;
using NUnit.Framework;

namespace IncrementDecrementTest
{
	public class NUnitIcuBase
	{
		private GuiHelper guiHelper = new GuiHelper();
		/// <summary>
		/// Ruft den GuiHelper, welcher die Kommunikation mit der GUI kapselt, ab oder legt diesen fest.
		/// </summary>
		public GuiHelper GuiHelper
		{
			get { return guiHelper; }
			set { guiHelper = value; }
		}

		protected IcuTest icu;
		/// <summary>
		/// Ruft die IcuTest-Instanz ab oder legt diese fest.
		/// </summary>
		public virtual IcuTest ICU
		{
			get
			{
				if (icu == null)
				{
					//IcuFromType setzt den Pfad auf "C:\Users\benutzername\Documents\IcuTests\this.GetType()-Ergebnis" fest
					icu = IcuTestStarter.IcuFromType(this.GetType());
				}
				return icu;
			}
		}

		[SetUp]
		public void TestInitialize()
		{
			// Optionale Konfigurationen
			var machine = System.Environment.MachineName;
			var user = System.Environment.UserName;

			if (machine.Equals("TestingMachine") && user.Equals("tobmuell"))
			{
				// Tests ohne Benutzerinteraktion durchführen.
				// Nur ausgeben, ob Test korrekt oder nicht korrekt durchgeführt wurde.
				ICU.Config.TestDirectory = @"c:\icu_test_verzeichnis";
				ICU.Config.IsEnabled = false;
				ICU.Config.PassNewTests = true;
				ICU.Config.OnFailShowDialog = false;
				ICU.Config.OnPassShowTest = true;
			}
			else
			{
				ICU.Config.TestDirectory = @"c:\icu_test_verzeichnis";
			}

			ICU.BeginTest(null); // Bentzer muss BeginTest manuell aufrufen
		}

		[TearDown]
		public void TestCleanup()
		{
			ICU.EndTest();
		}
	}
}
